/* ==========================================================================
 * This file is part of the Trusted Platform Agent (TPA)
 *
 * Copyright (C) 2007-2010 Politecnico di Torino, Italy
 * TORSEC group -- http://security.polito.it
 *
 * Trusted Platform Agent (TPA) is copyrighted free software by Politecnico
 * di Torino (TORSEC group).  You can redistribute it and/or modify it under
 * either the terms of the LGPL (see COPYING.LESSER file), or the GPL (see
 * COPYING file).
 *
 * DISCLAIMER of WARRANTY
 *
 * The following software "Trusted Platform Agent (TPA)" developed for
 * Open_TC project (http://www.opentc.net), whilst this version is not
 * endorsed by Open_TC, is experimental and is provided "as is", and no
 * guarantee or warranty is given by Politecnico di Torino (TORSEC group),
 * that the software is fit for any particular purpose.
 * The user thereof uses the software at its sole risk and liability.
 * Politecnico di Torino (TORSEC group) shall have no obligation to maintain
 * or support this software.  Politecnico di Torino (TORSEC group) MAKES NO
 * EXPRESS OR IMPLIED WARRANTY OF ANY KIND REGARDING THIS SOFTWARE.
 * Politecnico di Torino SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER BASED ON
 * CONTRACT, TORT OR ANY OTHER LEGAL THEORY, IN CONNECTION WITH OR
 * ARISING OUT OF THE FURNISHING, PERFORMANCE OR USE OF THIS SOFTWARE.
 * ==========================================================================
 */
#ifndef TPA_CONFIG_H_
#define TPA_CONFIG_H_

/*
 * Default parameters
 */
#define __ENV_VARIABLE_OR_DEFAULT(__env,__dft)   ((getenv(__env) != NULL) ? getenv(__env) : __dft)

#define TPA_DEFAULT_LOCAL_STORAGE		__ENV_VARIABLE_OR_DEFAULT("TPA_DEFAULT_LOCAL_STORAGE","/usr/local/var/lib/tpa/")
#define TPA_DEFAULT_LOCAL_STORAGE_FILE	__ENV_VARIABLE_OR_DEFAULT("TPA_DEFAULT_LOCAL_STORAGE_FILE","tpa.db")
#define TPA_TPM_DEFAULT_OWNERPWD		__ENV_VARIABLE_OR_DEFAULT("TPA_TPM_DEFAULT_OWNERPWD","ownerpwd")
#define TPA_TPM_DEFAULT_AIKPWD			__ENV_VARIABLE_OR_DEFAULT("TPA_TPM_DEFAULT_AIKPWD","aikpwd")
#define TPA_TPM_DEFAULT_SRKPWD			__ENV_VARIABLE_OR_DEFAULT("TPA_TPM_DEFAULT_SRKPWD","srkpwd")
#define TPA_PCA_DEFAULT_PCA_URI			__ENV_VARIABLE_OR_DEFAULT("TPA_PCA_DEFAULT_PCA_URI","localhost")
#define TPA_PCA_DEFAULT_PCA_PORT		__ENV_VARIABLE_OR_DEFAULT("TPA_PCA_DEFAULT_PCA_PORT", "10000")
#define TPA_EK_DEFAULT_CERT_FILENAME	__ENV_VARIABLE_OR_DEFAULT("TPA_EK_DEFAULT_FILENAME", "ek.cert")

#endif
