/* ==========================================================================
 * This file is part of the Trusted Platform Agent (TPA)
 *
 * Copyright (C) 2007-2010 Politecnico di Torino, Italy
 * TORSEC group -- http://security.polito.it
 *
 * Trusted Platform Agent (TPA) is copyrighted free software by Politecnico
 * di Torino (TORSEC group).  You can redistribute it and/or modify it under
 * either the terms of the LGPL (see COPYING.LESSER file), or the GPL (see
 * COPYING file).
 *
 * DISCLAIMER of WARRANTY
 *
 * The following software "Trusted Platform Agent (TPA)" developed for
 * Open_TC project (http://www.opentc.net), whilst this version is not
 * endorsed by Open_TC, is experimental and is provided "as is", and no
 * guarantee or warranty is given by Politecnico di Torino (TORSEC group),
 * that the software is fit for any particular purpose.
 * The user thereof uses the software at its sole risk and liability.
 * Politecnico di Torino (TORSEC group) shall have no obligation to maintain
 * or support this software.  Politecnico di Torino (TORSEC group) MAKES NO
 * EXPRESS OR IMPLIED WARRANTY OF ANY KIND REGARDING THIS SOFTWARE.
 * Politecnico di Torino SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER BASED ON
 * CONTRACT, TORT OR ANY OTHER LEGAL THEORY, IN CONNECTION WITH OR
 * ARISING OUT OF THE FURNISHING, PERFORMANCE OR USE OF THIS SOFTWARE.
 * ==========================================================================
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "TPA_API.h"

#define FIELD_SIZE 50
#define PCR_SIZE 20

#if 0
void ca_usage (char * programName) {
	printf ("Usage:\n");

	printf ("%s ca [SUBCOMMAND]\n", programName);

	printf ("   locate,\t\tlocate an AIK on the CA\n");
	printf ("\toptions:\n");
	printf ("\t   -l label\tspecify the label of the AIK to locate\n");
}

int ca_locate (int argc, char ** argv) {
	int c;
	TPA_AIK * aik;
	//char *cvalue = NULL;
	TPA_CONTEXT *ctx = (TPA_CONTEXT *) malloc (sizeof (TPA_CONTEXT));
	TPA_CA *ca = (TPA_CA *) malloc (sizeof (TPA_CA));

	//int i;

	/*
	 * This function will allocate a new AIK object
	 */
	TpaHL_AIK_allocate (&aik);

	while ((c = getopt (argc, argv, "l:")) != -1) {
		switch (c) {
			case 'l':
				TpaHL_AIK_set (aik, AIK_LABEL, strlen(optarg), optarg);
				break;
			case '?':
				ca_usage (argv[0]);
				exit (0);
				break;
			default:
				printf ("Internal error!\n");
				exit (0);
				break;
		}
	}


	if (TpaHL_AIK_Locate (ctx, aik, ca) == TPA_SUCCESS) {
		printf ("AIK found on the CA\n");
		return TPA_SUCCESS;
	}
	else {
		printf ("AIK not found on the CA!\n");
		return TPA_ERROR;
	}
	return TPA_ERROR;
}

int ca_locate2 (int argc, char ** argv) {
	int c;
	TPA_AIK * aik;
	//char *cvalue = NULL;
	TPA_CONTEXT *ctx;
	TPA_CA *ca = (TPA_CA *) malloc (sizeof (TPA_CA));

	//int i;

	TpaHL_CTX_allocate (&ctx);

	/*
	 * This function will allocate a new AIK object
	 */
	TpaHL_AIK_allocate (&aik);

	while ((c = getopt (argc, argv, "l:t:s:")) != -1) {
		switch (c) {
			case 'l':
				TpaHL_AIK_set (aik, AIK_LABEL, strlen(optarg), optarg);
				break;
			case 't':
				TpaHL_CTX_set (ctx, CTX_JTOOLS_URI, strlen(optarg), optarg);
				break;
			case 's':
				TpaHL_CTX_set (ctx, CTX_LS_URI, strlen(optarg), optarg);
				break;
			case '?':
				ca_usage (argv[0]);
				exit (0);
				break;
			default:
				printf ("Internal error!\n");
				exit (0);
				break;
		}
	}


	if (TpaHL_AIK_Locate (ctx, aik, ca) == TPA_SUCCESS) {
		printf ("AIK found on the CA\n");
	}
	else {
		printf ("AIK not found on the CA!\n");
	}

	/* TODO : fix me*/
	return TPA_SUCCESS;
}


/*
 * NOT WORKING YET!
 */
int ca_validate (int argc, char ** argv) {
//	int c;
//	TPA_AIK aik;
////	char *cvalue = NULL;
//
////	int i;
//
//	aikNew (&aik);
//
//	while ((c = getopt (argc, argv, "l:f:")) != -1) {
//		switch (c) {
//			case 'l':
//				strncpy (aik.label, optarg, FIELD_SIZE);
//				break;
//			case 'f':
//				strncpy (aik.cert, optarg, FIELD_SIZE);
//				break;
//			case '?':
//				printf ("c: %c\n", c);
//				usage (argv[0]);
//				exit (0);
//				break;
//			default:
//				printf ("Internal error!\n");
//				exit (0);
//				break;
//		}
//	}
//
//
//	if (TpaHL_AIK_Validate (NULL, &aik, NULL) == TPA_SUCCESS) {
//		printf ("AIK is valid\n");
//	}
//	else {
//		printf ("AIK is not valid!\n");
//	}
	return TPA_SUCCESS;
}

int ca (int argc, char ** argv) {
	if (argc == 1) {
		ca_usage (argv[0]);
		exit (0);
	}
	else if (strcmp ("locate", argv[1]) == 0) {
		argc --;
		argv[1] = argv [0];
		argv ++;
		ca_locate (argc, argv);
	}
	else if (strcmp ("locate2", argv[1]) == 0) {
		argc --;
		argv[1] = argv [0];
		argv ++;
		ca_locate2 (argc, argv);
	}
	else if (strcmp ("validate", argv[1]) == 0) {
		argc --;
		argv[1] = argv [0];
		argv ++;
		ca_validate (argc, argv);
	}
	else {
		ca_usage (argv[0]);
		exit (0);
	}

	return TPA_SUCCESS;
}
#endif
