/* ==========================================================================
 * This file is part of the Trusted Platform Agent (TPA)
 *
 * Copyright (C) 2007-2010 Politecnico di Torino, Italy
 * TORSEC group -- http://security.polito.it
 *
 * Trusted Platform Agent (TPA) is copyrighted free software by Politecnico
 * di Torino (TORSEC group).  You can redistribute it and/or modify it under
 * either the terms of the LGPL (see COPYING.LESSER file), or the GPL (see
 * COPYING file).
 *
 * DISCLAIMER of WARRANTY
 *
 * The following software "Trusted Platform Agent (TPA)" developed for
 * Open_TC project (http://www.opentc.net), whilst this version is not
 * endorsed by Open_TC, is experimental and is provided "as is", and no
 * guarantee or warranty is given by Politecnico di Torino (TORSEC group),
 * that the software is fit for any particular purpose.
 * The user thereof uses the software at its sole risk and liability.
 * Politecnico di Torino (TORSEC group) shall have no obligation to maintain
 * or support this software.  Politecnico di Torino (TORSEC group) MAKES NO
 * EXPRESS OR IMPLIED WARRANTY OF ANY KIND REGARDING THIS SOFTWARE.
 * Politecnico di Torino SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER BASED ON
 * CONTRACT, TORT OR ANY OTHER LEGAL THEORY, IN CONNECTION WITH OR
 * ARISING OUT OF THE FURNISHING, PERFORMANCE OR USE OF THIS SOFTWARE.
 * ==========================================================================
 */
#ifndef TPA_AIK_H_
#define TPA_AIK_H_

#include "TPA_Common.h"

TPA_RESULT Tpa_AIK_Create(TPA_TPM *tpm, TPA_AIK *aik, TPA_PCA *ca);
TPA_RESULT Tpa_AIK_Locate(TPA_AIK *aik, TPA_PCA *ca,
		TPA_CERTIFICATE_ITEM **cert_list);
TPA_RESULT Tpa_AIK_Validate(TPA_AIK *aik, TPA_PCA *ca,
		TPA_CERTIFICATE_ITEM **cert_list, TPA_VERIFICATION_RESULT *ver);
TPA_RESULT Tpa_AIK_Revoke(TPA_TPM *tpm, TPA_AIK *aik, TPA_PCA *ca);

#endif /* TPA_AIK_H_ */
