/* ==========================================================================
 * This file is part of the Trusted Platform Agent (TPA)
 *
 * Copyright (C) 2007-2010 Politecnico di Torino, Italy
 * TORSEC group -- http://security.polito.it
 *
 * Trusted Platform Agent (TPA) is copyrighted free software by Politecnico
 * di Torino (TORSEC group).  You can redistribute it and/or modify it under
 * either the terms of the LGPL (see COPYING.LESSER file), or the GPL (see
 * COPYING file).
 *
 * DISCLAIMER of WARRANTY
 *
 * The following software "Trusted Platform Agent (TPA)" developed for
 * Open_TC project (http://www.opentc.net), whilst this version is not
 * endorsed by Open_TC, is experimental and is provided "as is", and no
 * guarantee or warranty is given by Politecnico di Torino (TORSEC group),
 * that the software is fit for any particular purpose.
 * The user thereof uses the software at its sole risk and liability.
 * Politecnico di Torino (TORSEC group) shall have no obligation to maintain
 * or support this software.  Politecnico di Torino (TORSEC group) MAKES NO
 * EXPRESS OR IMPLIED WARRANTY OF ANY KIND REGARDING THIS SOFTWARE.
 * Politecnico di Torino SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER BASED ON
 * CONTRACT, TORT OR ANY OTHER LEGAL THEORY, IN CONNECTION WITH OR
 * ARISING OUT OF THE FURNISHING, PERFORMANCE OR USE OF THIS SOFTWARE.
 * ==========================================================================
 */
#ifndef TPA_DATA_H_
#define TPA_DATA_H_

#include "TPA_Common.h"

TPA_RESULT Tpa_DATA_BindBlob(TPA_TPM *tpm, TPA_TPMKEY *key,
		unsigned char *plainblob, unsigned int plainblob_size,
		unsigned char **boundblob, unsigned int *boundblob_size);
TPA_RESULT Tpa_DATA_UnbindBlob(TPA_TPM *tpm, unsigned char *boundblob,
		unsigned int boundblob_size, TPA_TPMKEY *key,
		unsigned char **unboundblob, unsigned int *unboundblob_size);
TPA_RESULT Tpa_DATA_SealBlob(TPA_TPM *tpm, unsigned char *plainblob,
		unsigned int plainblob_size, TPA_PCR_SET *selectedPcrs,
		unsigned char *mkBlob, unsigned int mkBlob_size,
		unsigned char **sealedblob, unsigned int *sealedblob_size);
TPA_RESULT Tpa_DATA_UnsealBlob(TPA_TPM *tpm, unsigned char *sealedblob,
		unsigned int sealedblob_size, unsigned char *mkBlob,
		unsigned int mkBlob_size, unsigned char **unsealedblob,
		unsigned int *unsealedblob_size);

/* old iface */
TPA_RESULT Tpa_CreateMKBlob(TPA_TPM *tpm, unsigned char **mkBlob,
		unsigned int *mkBlob_size);
TPA_RESULT Tpa_SealBlob(TPA_TPM *tpm, unsigned char *plainblob,
		unsigned int plainblob_size, TPA_PCR_SET *selectedPcrs,
		unsigned char *mkBlob, unsigned int mkBlob_size,
		unsigned char **sealedblob, unsigned int *sealedblob_size);
TPA_RESULT Tpa_UnsealBlob(TPA_TPM *tpm, unsigned char *sealedblob,
		unsigned int sealedblob_size, unsigned char *mkBlob,
		unsigned int mkBlob_size, unsigned char **unsealedblob,
		unsigned int *unsealedblob_size);

#endif /* TPA_DATA_H_ */
