/* ==========================================================================
 * This file is part of the Trusted Platform Agent (TPA)
 *
 * Copyright (C) 2007-2010 Politecnico di Torino, Italy
 * TORSEC group -- http://security.polito.it
 *
 * Trusted Platform Agent (TPA) is copyrighted free software by Politecnico
 * di Torino (TORSEC group).  You can redistribute it and/or modify it under
 * either the terms of the LGPL (see COPYING.LESSER file), or the GPL (see
 * COPYING file).
 *
 * DISCLAIMER of WARRANTY
 *
 * The following software "Trusted Platform Agent (TPA)" developed for
 * Open_TC project (http://www.opentc.net), whilst this version is not
 * endorsed by Open_TC, is experimental and is provided "as is", and no
 * guarantee or warranty is given by Politecnico di Torino (TORSEC group),
 * that the software is fit for any particular purpose.
 * The user thereof uses the software at its sole risk and liability.
 * Politecnico di Torino (TORSEC group) shall have no obligation to maintain
 * or support this software.  Politecnico di Torino (TORSEC group) MAKES NO
 * EXPRESS OR IMPLIED WARRANTY OF ANY KIND REGARDING THIS SOFTWARE.
 * Politecnico di Torino SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER BASED ON
 * CONTRACT, TORT OR ANY OTHER LEGAL THEORY, IN CONNECTION WITH OR
 * ARISING OUT OF THE FURNISHING, PERFORMANCE OR USE OF THIS SOFTWARE.
 * ==========================================================================
 */
#ifndef TPA_LS_DRIVER_H_
#define TPA_LS_DRIVER_H_

#include "TPA_Common.h"

#define TPA_LS_DRV__NOT_SUPPORTED              (uint32_t)0x000000FF
#define TPA_LS_DRV__NOT_IMPLEMENTED            (uint32_t)0x000000FE
#define TPA_LS_DRV_MAX_DRV                                       10

struct tpa_ls_drv {
	char *Tpa_LS_name;
	TPA_RESULT (*Tpa_LS_Init) (TPA_LS *ls);
	TPA_RESULT (*Tpa_LS_Open) (TPA_LS *ls);
	TPA_RESULT (*Tpa_LS_Close)(TPA_LS *ls);
	TPA_RESULT (*Tpa_LS_KeyLoad)         (TPA_LS *ls, TPA_KEY *key);
	TPA_RESULT (*Tpa_LS_KeyStore)        (TPA_LS *ls, TPA_KEY *key);
	TPA_RESULT (*Tpa_LS_KeyDelete)       (TPA_LS *ls, TPA_KEY *key);
	TPA_RESULT (*Tpa_LS_KeyList)         (TPA_LS *ls, TPA_KEY *key);
	TPA_RESULT (*Tpa_LS_KeyIsPresent)    (TPA_LS *ls, TPA_KEY *key);
	TPA_RESULT (*Tpa_LS_MeasureStore)    (TPA_LS *ls, TPA_MEASURE *measure);
	TPA_RESULT (*Tpa_LS_MeasureDeleteAll)(TPA_LS *ls);
	TPA_RESULT (*Tpa_LS_MeasureSetList)  (TPA_LS *ls, TPA_MEASURE_SET *measure_set);
	TPA_RESULT (*Tpa_LS_MeasureSetDelete)(TPA_LS *ls, TPA_MEASURE_SET *measure_set);
};

#ifdef TPA_LS_DRIVER
TPA_RESULT Tpa_LS_DriverEntry(TPA_LS_DRV *driver_obj);
#endif

#endif /* TPA_LS_DRIVER_H_ */
