/* ==========================================================================
 * This file is part of the Trusted Platform Agent (TPA)
 *
 * Copyright (C) 2007-2010 Politecnico di Torino, Italy
 * TORSEC group -- http://security.polito.it
 *
 * Trusted Platform Agent (TPA) is copyrighted free software by Politectnico
 * di Torino (TORSEC group).  You can redistribute it and/or modify it under
 * either the terms of the LGPL (see COPYING.LESSER file), or the GPL (see
 * COPYING file).
 *
 * DISCLAIMER of WARRANTY
 *
 * The following software "Trusted Platform Agent (TPA)" developed for
 * Open_TC project (http://www.opentc.net), whilst this version is not
 * endorsed by Open_TC, is experimental and is provided "as is", and no
 * guarantee or warranty is given by Politecnico di Torino (TORSEC group),
 * that the software is fit for any particular purpose.
 * The user thereof uses the software at its sole risk and liability.
 * Politecnico di Torino (TORSEC group) shall have no obligation to maintain
 * or support this software.  Politecnico di Torino (TORSEC group) MAKES NO
 * EXPRESS OR IMPLIED WARRANTY OF ANY KIND REGARDING THIS SOFTWARE.
 * Politecnico di Torino SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER BASED ON
 * CONTRACT, TORT OR ANY OTHER LEGAL THEORY, IN CONNECTION WITH OR
 * ARISING OUT OF THE FURNISHING, PERFORMANCE OR USE OF THIS SOFTWARE.
 * ==========================================================================
 */
#ifndef TPA_MEASURE_H_
#define TPA_MEASURE_H_

#include "TPA_Common.h"

/* module */
TPA_RESULT Tpa_Measure_allocateModule(TPA_MODULE_MEASURE **mod, TPA_LS *ls);
void Tpa_Measure_freeModuleMemory(TPA_MODULE_MEASURE *mod);

/* measure */
TPA_RESULT Tpa_Measure_allocate(TPA_MEASURE **measure);
void Tpa_Measure_freeMemory(TPA_MEASURE *measure, int do_free);
TPA_RESULT Tpa_Measure_File(TPA_MODULE_MEASURE *mod, int type,
		const char *filename, char *label, unsigned int label_len,
		TPA_MEASURE **measure);
TPA_RESULT Tpa_Measure_Blob(TPA_MODULE_MEASURE *mod, int type,
		unsigned char *blob, unsigned int blob_size, char *label,
		unsigned int label_len, TPA_MEASURE **measure);
TPA_RESULT Tpa_Measure_Create(TPA_MODULE_MEASURE *mod, int type,
		unsigned char *value, unsigned int value_size, char *label,
		unsigned int label_len, TPA_MEASURE **measure);
TPA_RESULT Tpa_Measure_DeleteAll(TPA_MODULE_MEASURE *mod);

/* measure set */
TPA_RESULT Tpa_MeasureSet_VerifyPcrs(TPA_MEASURE_SET *measuresIn,
		TPA_PCR_SET *selectedPcrs, TPA_MEASURE_SET **measuresOut,
		TPA_VERIFICATION_RESULT *vres);

/* callbacks */
TPA_RESULT Tpa_Measure_Callback_dlopen(TPA_MODULE_MEASURE *mod, char *filename);
TPA_RESULT Tpa_Measure_Callback_fopen(TPA_MODULE_MEASURE *mod, char *filename);

#endif /* TPA_MEASURE_H_ */
