/* ==========================================================================
 * This file is part of the Trusted Platform Agent (TPA)
 *
 * Copyright (C) 2007-2010 Politecnico di Torino, Italy
 * TORSEC group -- http://security.polito.it
 *
 * Trusted Platform Agent (TPA) is copyrighted free software by Politecnico
 * di Torino (TORSEC group).  You can redistribute it and/or modify it under
 * either the terms of the LGPL (see COPYING.LESSER file), or the GPL (see
 * COPYING file).
 *
 * DISCLAIMER of WARRANTY
 *
 * The following software "Trusted Platform Agent (TPA)" developed for
 * Open_TC project (http://www.opentc.net), whilst this version is not
 * endorsed by Open_TC, is experimental and is provided "as is", and no
 * guarantee or warranty is given by Politecnico di Torino (TORSEC group),
 * that the software is fit for any particular purpose.
 * The user thereof uses the software at its sole risk and liability.
 * Politecnico di Torino (TORSEC group) shall have no obligation to maintain
 * or support this software.  Politecnico di Torino (TORSEC group) MAKES NO
 * EXPRESS OR IMPLIED WARRANTY OF ANY KIND REGARDING THIS SOFTWARE.
 * Politecnico di Torino SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT,
 * SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER BASED ON
 * CONTRACT, TORT OR ANY OTHER LEGAL THEORY, IN CONNECTION WITH OR
 * ARISING OUT OF THE FURNISHING, PERFORMANCE OR USE OF THIS SOFTWARE.
 * ==========================================================================
 */
#ifndef TPA_UTILS_H_
#define TPA_UTILS_H_

#include "TPA_Common.h"
#include <stdio.h>

/****************************************************************************/
/* BLOB                                                                     */
/****************************************************************************/
TPA_RESULT Tpa_BLOB_copy(unsigned char *blobIn, unsigned int blobIn_size,
		unsigned char **blobOut, unsigned int *blobOut_size);
TPA_RESULT Tpa_BLOB_readFromFile(char * filename, unsigned char ** blob,
		unsigned int *blob_size);
TPA_RESULT Tpa_BLOB_writeToFile(char *filename, unsigned char *blob,
		unsigned int blob_size);
TPA_RESULT Tpa_BLOB_Digest(unsigned char *blob, unsigned int blob_len,
		unsigned char **digest, unsigned int *digest_len);

/* older and deprecated */
TPA_RESULT Tpa_setMember(void ** member, long len, void * data);
TPA_RESULT Tpa_setString(void ** member, long len, void * data);

#endif
