#include <stdarg.h>
#include <stddef.h>
#include <setjmp.h>

#include "TPA_TEST.h"
#include "cmockery.h"

/* Clear local storage */
void clear_LS() {
	struct dirent *d;
	DIR *dir;
#define BUFSIZE 256
	char buf[BUFSIZE];
	dir = opendir(TPA_DEFAULT_LOCAL_STORAGE);
	while ((d = readdir(dir))) {
		snprintf(buf, BUFSIZE, "%s/%s", TPA_DEFAULT_LOCAL_STORAGE, d->d_name);
		remove(buf);
	}
}

/* A test case that does nothing and succeeds. */
void null_test_success(void **state) {
	TPA_PCR *pcr = NULL;

	assert_int_equal(TpaHL_PCR_allocate(&pcr), TPA_SUCCESS);

	assert_int_equal(pcr->pcr, 0);
	assert_int_equal(pcr->pcr_size, 20);
	assert_int_equal((int) pcr->value, (int) NULL);

	assert_int_equal(TpaHL_PCR_set(pcr, 0, 0, NULL), TPA_NOT_IMPLEMENTED);

	TpaHL_PCR_freeMemory(pcr);
}

int main(int argc, char* argv[]) {
	const UnitTest misc_tests[] = { unit_test(null_test_success), };

	const UnitTest constructor_tests[] = {
			unit_test(CTX_allocate_test_success), unit_test(
					TPM_allocate_test_success), };

//	const UnitTest functional_tests[] = { unit_test(bind_test_success), };

	const UnitTest meas_tests[] = { unit_test(meas_test_success), };

	run_tests(misc_tests);
	run_tests(constructor_tests);
	run_tests(meas_tests);

	return 0;
}

